/*
Copyright (c) 2023 : Ognjen 'xolatile' Milan Robovic

Xurses is free software! You will redistribute it or modify it under the terms of the GNU General Public License by Free Software Foundation.
And when you do redistribute it or modify it, it will use either version 3 of the License, or (at yours truly opinion) any later version.
It is distributed in the hope that it will be useful or harmful, it really depends... But no warranty what so ever, seriously. See GNU/GPLv3.
*/

#ifndef XURSES_HEADER
#define XURSES_HEADER

extern int curses_realign_x;
extern int curses_realign_y;
extern int curses_tab_width;
extern int curses_signal;
extern int curses_screen_width;
extern int curses_screen_height;
extern int curses_active;

extern void curses_configure   (void);
extern void curses_synchronize (void);

extern void curses_bind   (int signal, void (* action) (void));
extern void curses_unbind (int signal);

extern void curses_render_cursor (int x, int y);

extern void curses_render_character  (char character, int colour, int effect, int x, int y);
extern void curses_render_background (char character, int colour, int effect);

extern void curses_render_string_point (char * string, int limit, int colour, int effect, int * x, int * y);
extern void curses_render_number_point (int    number, int limit, int colour, int effect, int * x, int * y);

extern void curses_render_string_limit (char * string, int limit, int colour, int effect, int x, int y);
extern void curses_render_number_limit (int    number, int limit, int colour, int effect, int x, int y);

extern void curses_render_string (char * string, int colour, int effect, int x, int y);
extern void curses_render_number (int    number, int colour, int effect, int x, int y);

#endif
